#ifndef PWM_TIMER_H
#define PWM_TIMER_H

#include <stm32f0xx.h>
#include "output-compare-channel.hpp"

class PwmTimer {
   private:
	TIM_TypeDef* _timer;
	OutputCompareChannel _OCC;
	uint16_t _pwmResolution;
	uint16_t _pwmFrequency;

   public:
	PwmTimer(TIM_TypeDef* timer, OutputCompareChannel OCC, uint16_t pwmResolution, uint16_t pwmFrequency);
	PwmTimer(TIM_TypeDef* timer,
	         OutputCompareChannel OCC,
	         uint16_t pwmResolution,
	         uint16_t pwmFrequency,
	         uint16_t initalDutyCycle);
	void setDutyCycle(uint16_t compareValue);
	void setDutyCyclePercentage(uint8_t dutyCyclePercentage);

   private:
	void enableTimer();
	void setupOutputChannel();
};

#endif
